Conversion Tools - Bug #3312

DEFINE BUFFER with TEMP-TABLE fails to resolve persistent table
07/18/2017 04:51 PM - Hynek Cihlar

Status: New Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Estimated time: 0.00 hour

Target version:

billable: No case_hum:
vendor_id: GCD version:
Description

History

#1 - 07/18/2017 04:55 PM - Hynek Cihlar

The following case fails to convert in FWD while it does work in native 4gl.

/* this assumes a default connected database with CUSTOMER table and field NAME */
DEFINE BUFFER bt FOR TEMP-TABLE Customer.

FIND FIRST bt NO-ERROR.

MESSAGE bt.NAME. /* << valid name is printed in 4gl */

This issue relates to #3308-261.

#2 - 07/18/2017 04:59 PM - Hynek Cihlar

When DEFINE-TABLE is present in the DEFINE BUFFER statement, it is used as a hint by the 4gl compiler to prefer a temp-table if the for-table in
the statement yields a persistent and temp table. However when only persistent table is resolved the keyword doesn't prevent the compiler to use that
table. See below for the possible cases.

/** the test assumes default connected database with tables ADDRESS and field STREET AS CHAR and
table BOOK with field ISBN AS CHAR */

DEFINE TEMP-TABLE Address FIELD xyz AS CHARACTER.

/** when TEMP-TABLE is present, the temp table Address is resolved */
DEFINE BUFFER bt FOR TEMP-TABLE Address.

FIND FIRST bt NO-ERROR.

MESSAGE bt.xyz.

/** when TEMP-TABLE is not present, the persistent table Address is resolved */
DEFINE BUFFER bt2 FOR Address.

FIND FIRST bt2 NO-ERROR.

MESSAGE bt2.street.

DEFINE TEMP-TABLE OnlyTemp FIELD xyz AS CHARACTER.
/** when TEMP-TABLE is present, the temp table OnlyTemp is resolved */

DEFINE BUFFER bt3 FOR TEMP-TABLE OnlyTemp.
FIND FIRST bt3 NO-ERROR.
MESSAGE bt3.xyz.

/** when TEMP-TABLE is not present, still the temp table OnlyTemp is resolved */
DEFINE BUFFER bt4 FOR OnlyTemp.

FIND FIRST bt4 NO-ERROR.

MESSAGE bt4.xyz.

/** when TEMP-TABLE is present, the persistent table Book is resolved */
DEFINE BUFFER bt5 FOR TEMP-TABLE Book.

FIND FIRST bt5 NO-ERROR.

MESSAGE bt5.isbn.

/** when TEMP-TABLE is not present, the persistent table Book is resolved */
DEFINE BUFFER bt6 FOR Book.

FIND FIRST bt6 NO-ERROR.

MESSAGE bt6.isbn.

#3 - 07/18/2017 05:04 PM - Hynek Cihlar
- File table_lookup.diff added

See the attached diff which fixes the name resolution (the diff was made against current branch 1514a). However there is a subsequent problem:

Code Conversion Annotations

Optional rule set [customer_specific_annotations_prep] not found.
./hynek/test.p

Elapsed job time: 00:00:00.839

ERROR:

com.goldencode.p2j.pattern.TreeWalkException: ERROR! Active Rule:

RULE REPORT

Rule Type : WALK

Source AST: [ bt2.street ] BLOCK/STATEMENT/KW_MSG/CONTENT_ARRAY/EXPRESSION/FIELD_CHAR/ @14:9 {12884901975}
Copy AST 8 [ bt2.street ] BLOCK/STATEMENT/KW_MSG/CONTENT_ARRAY/EXPRESSION/FIELD_CHAR/ @14:9 {12884901975}
Condition : Jjavaname = p20.javaPropertyName (getNoteString ("schemaname"), false)

Loop : false

——— END RULE REPORT —---

at com.goldencode.p2j.pattern.PatternEngine.run (PatternEngine. java:1063)
at com.goldencode.p2j.convert.ConversionDriver.processTrees (ConversionDriver.java:1076)
at com.goldencode.p2j.convert.ConversionDriver.back (ConversionDriver. java:929)
at com.goldencode.p2j.convert.ConversionDriver.main (ConversionDriver. java:1950)
Caused by: java.lang.NullPointerException
at com.goldencode.p2j.schema.P20Lookup.getJavaName (P20Lookup. java:982)
at com.goldencode.p2j.schema.P20Lookup.javaName (P20Lookup. java:579)
at com.goldencode.p2j.schema.P20Lookup. javaPropertyName (P20Lookup. java:683)
at com.goldencode.p2j.schema.P20Lookup. javaPropertyName (P20Lookup. java:650)
at com.goldencode.p2j.schema.P20AccessWorker$Library.javaPropertyName (P20AccessWorker. java:263)
at com.goldencode.expr.CE6298.execute (Unknown Source)
at com.goldencode.expr.Expression.execute (Expression. java:373)
| am currently working on the NPE.

#4 - 07/19/2017 08:22 AM - Eric Faulhaber
Hynek Cihlar wrote:

See the attached diff which fixes the name resolution (the diff was made against current branch 1514a).

Hynek, this change looks like it could be ok, but this is a particularly tricky area of the code, so | can't tell from code review alone what the side effects
might be. If it fixes the problem at hand and you get past the NPE, please apply this change tentatively to 1514a and do a conversion-only regression
test against it. I'll do further testing with it overnight tonight.

#5 - 07/19/2017 08:25 AM - Hynek Cihlar

Eric Faulhaber wrote:
Hynek Cihlar wrote:

See the attached diff which fixes the name resolution (the diff was made against current branch 1514a).

Hynek, this change looks like it could be ok, but this is a particularly tricky area of the code,

Yes, the code | changed is also executed for LIKE and BEFORE-TABLE constructs. | have (passing) regression tests for these, too.

so | can't tell from code review alone what the side effects might be. If it fixes the problem at hand and you get past the NPE, please apply this
change tentatively to 1514a and do a conversion-only regression test against it. I'll do further testing with it overnight tonight.

Ok. | have found the problematic code responsible for the NPE, which happens further in the ast processing. | don't have a complete fix yet but | think
I am on the right track.
#6 - 08/02/2017 04:15 PM - Hynek Cihlar

The committed changes in 3312a resolve the issue only partially. There is at least one remaining problem in the AST generator.

DEFINE TEMP-TABLE Address FIELD xyz AS CHARACTER.
DEFINE BUFFER bt2 FOR Address.

FIND FIRST bt2 NO-ERROR.

MESSAGE bt2.street.

In the example above the parser already correctly resolves the persistent table in the DEFINE BUFFER statement and the example parses without
errors and exceptions, however the AST generator produces an invalid AST with TEMP-TABLE node under the DEFINE_BUFFER node. The
expected AST is to have a persistent table under DEFINE_BUFFER.

Files

table_lookup.diff 11.6 KB 07/18/2017 Hynek Cihlar
